## samba 4.23.4%2Bdfsg

=== debian/changelog ===
samba (2:4.23.4+dfsg-1ubuntu2) resolute; urgency=medium

  * No-change rebuild for Python 3.14 as the default.

 -- Andreas Hasenack <andreas.hasenack@canonical.com>  Mon, 26 Jan 2026 16:22:49 -0300

samba (2:4.23.4+dfsg-1ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable (LP: #2126006). Remaining changes:
    - Ubuntu i386 binary compatibility:
      + d/control: enable the liburing vfs module, except on i386 where
        liburing is not available
      + python3-samba depends on python3-cryptography, which Ubuntu doesn't
        build on i386 (LP #2099895):
        - d/control: don't recommend python3-samba on i386
        - d/rules: don't build python3-samba on ubuntu i386
    - d/t/control, d/t/util,d/t/samba-ad-dc-provisioning-internal-dns:
      samba AD DC provisioning and domain join tests with internal DNS
      (LP #1977746, LP #2011745)
    - d/control: make samba-vfs-modules-extra a transitional package.
      The glusterfs vfs module (the only vfs module shipped in it
      previously) is now in bin:samba-vfs-glusterfs. Can be dropped
      after 26.04.
    - d/control: have the (now transitional) samba-vfs-modules package
      depend on samba-vfs-ceph, so that upgrades retain the ceph vfs
      module
    - d/control: samba-vfs-modules and samba-vfs-modules-extra, now
      transitional packages, should only depend on the new samba-vfs-ceph and
      samba-vfs-glusterfs packages on the architectures where those two
      packages are built (LP #2076682)
    - d/control: samba-vfs-modules i386 adjustments:
      + samba-vfs-modules-extra was not built before for 32bit architectures,
        adjust Architectures line
      + samba-vfs-modules: this one was build for 32bit architectures before,
        so we need the conditional Depends for ceph
    - d/p/fix-motd-gpo-list-empty.patch: fix crash when listing an empty MOTD
      GPO
    - d/t/samba-ad-dc-provisioning-internal-dns: add MOTD GPO test
    - d/t/{control,smbclient-macro-expansion}: add test for macro expansion
      (related to LP #2120811)
  * Dropped:
    - SECURITY UPDATE: uninitialized memory disclosure via vfs_streams_xattr
      + debian/patches/CVE-2025-9640-1.patch: add torture test for inserting
        hole in stream in source3/selftest/tests.py, source4/torture/*.
      + debian/patches/CVE-2025-9640-2.patch: fix unitialized write in
        source3/modules/vfs_streams_xattr.c.
      + CVE-2025-9640
      [Fixed upstream in 4.23.2]
    - SECURITY UPDATE: command injection via WINS server hook script
      + debian/patches/CVE-2025-10230-1.patch: check that wins hook sanitizes
        names in python/samba/tests/usage.py, selftest/*, source4/torture/*,
        testprogs/blackbox/wins_hook_test.
      + debian/patches/CVE-2025-10230-2.patch: restrict names fed to shell in
        source4/nbt_server/wins/wins_hook.c.
      + CVE-2025-10230
      [Fixed upstream in 4.23.2]
    - d/control: adjust breaks/replaces for file move that Debian did in
      4.16.6+dfsg-5, and Ubuntu only did in 4.17.7+dfsg-1ubuntu1, to avoid
      file conflict in a dist-upgrade from earlier Ubuntu releases, like
      Kinetic (LP #2024663)
      [Only needed for upgrades from jammy to noble]
    - d/control: don't have bin:samba recommend bin:samba-ad-dc (LP #2101838)
      [In 2:4.23.0+dfsg-1]
  * Added:
    - d/control, d/samba-libs.install: remove the pkg.samba.builtin-ngtcp2
      build profile and the build dependency on libngtcp2 because it's in
      universe, and switch to the builtin version shipped with samba.
    - d/t/control: certain tests don't work on i386 in Ubuntu

 -- Andreas Hasenack <andreas.hasenack@canonical.com>  Fri, 09 Jan 2026 16:59:09 -0300

samba (2:4.23.4+dfsg-1) unstable; urgency=medium

  * new upstream stable/bugfix release:
   - https://bugzilla.samba.org/show_bug.cgi?id=15809:
     samba-bgqd: rework man page
   - https://bugzilla.samba.org/show_bug.cgi?id=15897:
     Assert failed: (dirfd != -1) || (smb_fname->base_name[0] == '/')
     in vfswrap_openat
   - https://bugzilla.samba.org/show_bug.cgi?id=15926:
     Samba 4.22 breaks Time Machine
   - https://bugzilla.samba.org/show_bug.cgi?id=15936:
     samba-bgqd can't find [printers] share
   - https://bugzilla.samba.org/show_bug.cgi?id=15947:
     mdssvc doesn't support $time.iso dates before 1970
   - https://bugzilla.samba.org/show_bug.cgi?id=15950:
     ctdb can crash with inconsistent cluster lock configuration
   - https://bugzilla.samba.org/show_bug.cgi?id=15955:
     Winbind can hang forever in gssapi if there are network issues
   - https://bugzilla.samba.org/show_bug.cgi?id=15961:
     libldb requires linking libreplace on Linux
   - https://bugzilla.samba.org/show_bug.cgi?id=15963:
  * d/patches: remove revert-ldb-use-hexchars_upper-from-replace.h.patch
    (applied upstream)

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 12 Dec 2025 23:10:50 +0300

samba (2:4.22.3+dfsg-4ubuntu4) resolute; urgency=medium

  * No-change rebuild for icu soname.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 03 Dec 2025 14:37:35 +0100

samba (2:4.22.3+dfsg-4ubuntu3) resolute; urgency=medium

  * No-change rebuild to fix amd64v3 publishing issue.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 12 Nov 2025 08:18:52 -0500

## samba 4.23.4+dfsg

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# build is done in bin/default/ subdir
DEB_CFLAGS_MAINT_APPEND = -ffile-prefix-map=../../=

ifneq (,$(filter armel mipsel m68k powerpc sh4,${DEB_HOST_ARCH}))
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358
# on these platforms gcc does not link with -latomic, resulting in
#   third_party/heimdal/lib/krb5/krcache.c.55.o: in function `krcc_get_principal':
#   third_party/heimdal/lib/krb5/krcache.c:1395: undefined reference to `__atomic_load_8'
#     ids.krcu_cache_and_princ_id = heim_base_atomic_load(&data->krc_cache_and_principal_id);
#   third_party/heimdal/lib/base/heimbase-atomics.h:
#     #include <stdatomic.h>
#     #define heim_base_atomic_load(x)        atomic_load((x))
# include a workaround for now
# (-latomic and <stdatomic.h> comes from gcc, --as-needed is already in use)
DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

ifneq (,$(filter m68k ,${DEB_HOST_ARCH}))
# without this, build fails with multiple messages like:
# foo.s:NNN: Error: Adjusted signed .word (0xb64a) overflows: `switch'-statement too large.
# when building third_party/heimdal/lib/asn1/asn1_rfc2459_asn1.c (generated)
# It would be best to enable this switch for a single file only (where it is needed)
DEB_CFLAGS_MAINT_APPEND += -mlong-jump-table-offsets
endif

include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
V := $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)
WAF := PYTHONHASHSEED=1 ./buildtools/bin/waf \
	$(patsubst parallel=%,-j%,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

# stop python from generating .pyc caches
export PYTHONDONTWRITEBYTECODE=1

ifeq (linux,${DEB_HOST_ARCH_OS})
ifneq (${DEB_HOST_GNU_TYPE},${DEB_BUILD_GNU_TYPE})
# for cross-build or build with foreign python binary (it is _gnu0_i386-gnu on hurd)
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__${DEB_HOST_ARCH_OS}_${DEB_HOST_MULTIARCH}
endif
endif

PYTHONDIR = /usr/lib/python3/dist-packages

DESTDIR = ${CURDIR}/debian/tmp

before-trixie := $(filter pkg.samba.before-trixie, ${DEB_BUILD_PROFILES})

subver-suffix := +samba${DEB_VERSION_UPSTREAM_REVISION}

# lib/ldb/wscript
ldb-upstream-version := 2.11.0
ldb-version = 2:${ldb-upstream-version}${subver-suffix}
ldb-packages := libldb2 libldb-dev ldb-tools python3-ldb

# lib/talloc/wscript
talloc-upstream-version := 2.4.3
talloc-version = 2:${talloc-upstream-version}${subver-suffix}
talloc-packages := libtalloc2 libtalloc-dev python3-talloc

# lib/tevent/wscript
tevent-upstream-version := 0.17.1
tevent-version = 2:${tevent-upstream-version}${subver-suffix}
libtevent := $(if ${before-trixie},libtevent0,libtevent0t64)
tevent-packages := ${libtevent} libtevent-dev

# lib/tdb/wscript
tdb-upstream-version := 1.4.14
tdb-version = 2:${tdb-upstream-version}${subver-suffix}
tdb-packages := libtdb1 tdb-tools libtdb-dev python3-tdb

extra-version-vars = \
	-Vldb:Version=${ldb-version} \

# used in libnss-winbind.install & libpam-winbind.install
export SYSLIBDIR = $(if ${before-trixie},/lib,/usr/lib)

omit-pkgs =

config-args = \
	--vendor-suffix=${DEB_VENDOR}-${DEB_VERSION_UPSTREAM_REVISION} \
	--prefix=/usr \
	--enable-fhs \
	--sysconfdir=/etc \
	--localstatedir=/var \
	--libexecdir=/usr/libexec \
	--libdir=/usr/lib/${DEB_HOST_MULTIARCH} \
	--datadir=/usr/share \
	--with-modulesdir=/usr/lib/${DEB_HOST_MULTIARCH}/samba \
	--with-pammodulesdir=${SYSLIBDIR}/${DEB_HOST_MULTIARCH}/security \
	--with-privatedir=/var/lib/samba/private \
	--with-smbpasswd-file=/etc/samba/smbpasswd \
	--with-piddir=/run/samba \
	--with-lockdir=/run/samba \
	--with-sockets-dir=/run/samba \
	--with-statedir=/var/lib/samba \
	--with-cachedir=/var/cache/samba \
	--with-pam \
	--with-syslog \
	--with-utmp \
	--with-winbind \
	--with-automount \
	--with-ldap \
	--with-ads \
	--with-gpgme \
	--enable-avahi \
	--enable-spotlight \
	--with-profiling-data \
	--disable-rpath --disable-rpath-install \
	--private-libraries=!ldb \
	--bundled-libraries=talloc,tevent,tdb \
	--pythondir=${PYTHONDIR} \
	--pythonarchdir=${PYTHONDIR} \
	\
	--with-cluster-support \
	--enable-etcd-reclock \
	--with-socketpath=/run/ctdb/ctdbd.socket \
	--with-logdir=/var/log/ctdb \

# some modules are linked statically by default (see default_static_module in wscript*),
# but they're often linked into other libraries, which might result in cyclic deps.
# Eg, vfs_dfs_samba4 is statically linked to libsmbd-base-private, which is part of
# samba-libs (not samba), because it is used by python3-samba too (smbd.cpython).
# Might consider using --with-shared-modules=ALL
# Other modules (vfs_nfs4acl_xattr) are not enabled by default (#930540).
config-args += \
	--with-shared-modules=vfs_dfs_samba4,vfs_nfs4acl_xattr,auth_samba4

ifeq (${DEB_HOST_ARCH_OS}, linux) # extra linux-specific features

config-args += \
	--with-quota \
	--with-systemd \

endif

# Ubuntu i386 binary compatibility only effort: Disable some i386 packages and modules
ifeq (${DEB_VENDOR}-${DEB_HOST_ARCH}, Ubuntu-i386)
omit-pkgs += ctdb libpam-winbind samba samba-ad-dc samba-testsuite samba-vfs-modules samba-vfs-ceph samba-vfs-glusterfs python3-samba
endif

# we had t64 transition (libsmbclient => libsmbclient0) for trixie
libsmbclient := $(if ${before-trixie},libsmbclient,libsmbclient0)

mitkrb5-dep-pkgs :=
ifneq (,$(filter pkg.samba.mitkrb5, ${DEB_BUILD_PROFILES}))
config-args += \
	--with-system-mitkrb5 \
	--with-experimental-mit-ad-dc \
	--with-system-mitkdc=/usr/sbin/krb5kdc
# samba packages will have its own version suffix
mitkrb5-samba-ver = ${DEB_VERSION}mitkrb5
mitkrb5-dep-pkgs += samba-libs samba-dev
mitkrb5-dep-pkgs += samba samba-common-bin python3-samba
mitkrb5-dep-pkgs += samba-vfs-ceph samba-vfs-glusterfs
mitkrb5-dep-pkgs += samba-dsdb-modules
mitkrb5-dep-pkgs += ${libsmbclient} smbclient
mitkrb5-dep-pkgs += libnss-winbind libpam-winbind
mitkrb5-dep-pkgs += winbind libwbclient0
mitkrb5-dep-pkgs += samba-testsuite
mitkrb5-dep-pkgs += ctdb
endif

ifneq (,${omit-pkgs})
export DH_OPTIONS += $(addprefix -N, ${omit-pkgs})
endif
# ${build-pkgs} will honour arch/indep and the above list in ${DH_OPTIONS}
build-pkgs := $(shell dh_listpackages)

with-ceph := $(filter samba-vfs-ceph,${build-pkgs})
config-args += $(if ${with-ceph},\
	  --enable-cephfs --enable-ceph-reclock,\
	  --disable-cephfs)

binary binary-arch binary-indep \
install install-arch install-indep: %:
	dh $*

configure: bin/configured.stamp
.PHONY: configure
bin/configured.stamp:
	CC="${CC}" CPP="${CPP}" LD="${LD}" PKGCONFIG="${PKG_CONFIG}" \
	CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" \
	PYTHON=python3 PYTHON_CONFIG=${DEB_HOST_MULTIARCH}-python3-config \
	    ${WAF} -j1 -C configure ${config-args} || \
	  { $(if ${V},echo "==== contents of config.log:"; cat bin/config.log;) false; }
# #1013205: https://lists.samba.org/archive/samba-technical/2022-November/137788.html
	rm -f third_party/heimdal/lib/gssapi/gssapi.h
	touch $@

build-arch: bin/built.stamp
bin/built.stamp: bin/configured.stamp
# samba build system is designed so that default build (what is produced
# by waf build) supposed to be run directly from the build directory,
# with all the paths pointing there.  At the install stage, quite some
# recompilation/relinking is done again, to adopt to the actual install
# paths. There's no need (for now) to build samba to be run from the build
# directory, so we use `waf install' here instead of `waf build'.
ifeq (,${mitkrb5-dep-pkgs})
# However, as of 4.16 and still 4.21, `waf install' without the build step fails,
# since it tries to run two executables which are not built.
# Build these two executables first, and build the install stage.
# This will pefrorm unnecessary/extra install step (into d/tmp), which

=== debian/tests/control ===
Tests: cifs-share-access
Depends: samba, coreutils, systemd, cifs-utils, passwd
Restrictions: needs-root, allow-stderr, isolation-machine
Architecture: !i386

Tests: cifs-share-access-uring
Depends: samba, coreutils, systemd, cifs-utils, passwd
Restrictions: needs-root, allow-stderr, isolation-machine, skippable
Architecture: !i386

Tests: python-smoke
Depends: python3-samba
Architecture: !i386

Tests: smbclient-anonymous-share-list
Depends: samba, smbclient
Restrictions: allow-stderr, isolation-container
Architecture: !i386

Tests: smbclient-authenticated-share-list
Depends: samba, smbclient, passwd
Restrictions: needs-root, allow-stderr, isolation-container
Architecture: !i386

Tests: smbclient-share-access
Depends: samba, smbclient, coreutils, systemd, passwd
Restrictions: needs-root, allow-stderr, isolation-container
Architecture: !i386

Tests: smbclient-share-access-uring
Depends: samba, smbclient, coreutils, systemd, passwd
Restrictions: needs-root, allow-stderr, isolation-container, skippable
Architecture: !i386

Tests: reinstall-samba-common-bin
Depends: samba-common, samba-common-bin
Restrictions: needs-root, needs-reboot, isolation-machine, allow-stderr

Tests: smbclient-macro-expansion
Depends: samba, smbclient
Restrictions: needs-root, allow-stderr, isolation-container
Architecture: !i386

Tests: samba-ad-dc-provisioning-internal-dns
Depends: samba-ad-dc, samba-ad-provision, smbclient, krb5-user, bind9-dnsutils, lxd | snapd, lsb-release, dctrl-tools, dpkg-dev
Restrictions: needs-root, isolation-machine, allow-stderr, breaks-testbed
Architecture: !i386

## samba 4.23.5+dfsg

=== debian/changelog ===
samba (2:4.23.5+dfsg-1ubuntu2) resolute; urgency=medium

  * No-change rebuild for gpgme1.0 2.0

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Thu, 19 Feb 2026 18:57:14 +0000

samba (2:4.23.5+dfsg-1ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable (LP: #2139074). Remaining changes:
    - Ubuntu i386 binary compatibility:
      + d/control: enable the liburing vfs module, except on i386 where
        liburing is not available
      + python3-samba depends on python3-cryptography, which Ubuntu doesn't
        build on i386 (LP #2099895):
        - d/control: don't recommend python3-samba on i386
        - d/rules: don't build python3-samba on ubuntu i386
    - d/t/control, d/t/util,d/t/samba-ad-dc-provisioning-internal-dns:
      samba AD DC provisioning and domain join tests with internal DNS
      (LP #1977746, LP #2011745)
    - d/control: make samba-vfs-modules-extra a transitional package.
      The glusterfs vfs module (the only vfs module shipped in it
      previously) is now in bin:samba-vfs-glusterfs. Can be dropped
      after 26.04.
    - d/control: have the (now transitional) samba-vfs-modules package
      depend on samba-vfs-ceph, so that upgrades retain the ceph vfs
      module
    - d/control: samba-vfs-modules and samba-vfs-modules-extra, now
      transitional packages, should only depend on the new samba-vfs-ceph and
      samba-vfs-glusterfs packages on the architectures where those two
      packages are built (LP #2076682)
    - d/control: samba-vfs-modules i386 adjustments:
      + samba-vfs-modules-extra was not built before for 32bit architectures,
        adjust Architectures line
      + samba-vfs-modules: this one was build for 32bit architectures before,
        so we need the conditional Depends for ceph
    - d/p/fix-motd-gpo-list-empty.patch: fix crash when listing an empty MOTD
      GPO
    - d/t/samba-ad-dc-provisioning-internal-dns: add MOTD GPO test
    - d/control, d/samba-libs.install: remove the pkg.samba.builtin-ngtcp2
      build profile and the build dependency on libngtcp2 because it's in
      universe, and switch to the builtin version shipped with samba.
    - d/t/control: certain tests don't work on i386 in Ubuntu
  * Dropped:
    - d/t/{control,smbclient-macro-expansion}: add test for macro expansion
      (related to LP #2120811)
      [In 2:4.23.5+dfsg-1]

 -- Andreas Hasenack <andreas.hasenack@canonical.com>  Wed, 11 Feb 2026 11:42:28 -0300

samba (2:4.23.5+dfsg-1) unstable; urgency=medium

  [ Michael Tokarev ]
  * new upstream bugfix release
  * use-explicit_bzero-to-zero-memory.diff: use explicit_bzero()
    to explicitly zero memory everywhere, not just for ZERO_STRUCT
  * heimdal-kdc-fix-memset_s-calls-1296.patch -
    fix some wrong memset_s usages
  * d/*.lintian-overrides: remove library-not-linked-against-libc tags
    (#896012 is now fixed)
  * inline-getprogname.diff, inline-openat2.diff - reduce libreplace usage
  * d/patches/series: remove old commented-out entry
  * add-support-for-bind-9.20.patch: remove, applied upstream

  [ Andreas Hasenack ]
  * Add DEP8 test for macro expansion in config file

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 24 Jan 2026 08:55:25 +0300

=== debian/control ===
# Available build profiles:
#  pkg.samba.before-trixie: no t64, no usrmerge, no rpcsvc-proto
#  pkg.samba.dumpmscat: build /usr/bin/dumpmscat binary
#  pkg.samba.mitkrb5: build with mit-krb5 kerberos instead of bundled heimdal
Source: samba
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Michael Tokarev <mjt@tls.msk.ru>
Homepage: https://www.samba.org
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13),
	dh-exec,
Build-Depends-Arch:
	dpkg-dev (>= 1.22.5) <!pkg.samba.before-trixie>,
# tools:
	bison,
	docbook-xml, docbook-xsl, xsltproc,
	flex,
	perl:any,
# :native for bookworm where the package in question does not have M-A markings:
	libparse-yapp-perl:native | libparse-yapp-perl,
	rpcsvc-proto  <!pkg.samba.before-trixie>,
# for winexe. gcc-mingw-w64 brings 4 toolchains, we need only 2
# :native for trixie where the package in question does not have M-A markings:
	gcc-mingw-w64-i686-win32:native | gcc-mingw-w64-i686-win32,
	gcc-mingw-w64-x86-64-win32:native | gcc-mingw-w64-x86-64-win32,
# system libraries:
	pkgconf,
	libacl1-dev,
	libarchive-dev,
	libavahi-client-dev,
	libavahi-common-dev,
	libblkid-dev,
	libbsd-dev,
	libcap-dev [linux-any],
# the same [arch list] is in ctdb.install
	libcephfs-dev [amd64 arm64 mips64el ppc64el riscv64 s390x],
	librados-dev  [amd64 arm64 mips64el ppc64el riscv64 s390x],
	libcmocka-dev,
	libcrypt-dev,
	libcups2-dev,
	libdbus-1-dev,
	libglusterfs-dev [amd64 arm64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
	libgnutls28-dev,
	libgpgme11-dev,
	libicu-dev,
	libjansson-dev,
	libkeyutils-dev [linux-any],
	libkrb5-dev (>= 1.21.0~) <pkg.samba.mitkrb5>,
	libldap2-dev,
	liblmdb-dev,
	libpam0g-dev,
	libpcap-dev [hurd-any],
	libpopt-dev,
	libreadline-dev,
	libtirpc-dev,
	libsystemd-dev [linux-any],
	libtasn1-6-dev <pkg.samba.dumpmscat>,
	libtasn1-bin <pkg.samba.dumpmscat>,
	liburing-dev [!i386],
# xfslibs-dev is not multi-arch-usable but we only need .h (#1092689)
	xfslibs-dev:native [linux-any],
	zlib1g-dev,
# python (+#904999):
# cross-build: native python environment, host-specific libpython-dev
# (see also d/rules, _PYTHON_SYSCONFIGDATA_NAME):
	python3-dev:native, libpython3-dev,
# :native for bookworm where the package in question does not have M-A markings:
	python3-dnspython:native | python3-dnspython,
	python3-etcd:native | python3-etcd,
	python3-markdown:native | python3-markdown,
	python3-setuptools,
	dh-sequence-python3,
# dependencies needed for selftest:
#	python3-testtools <!nocheck>,
#	lmdb-utils <!nocheck>,
#	openssl <!nocheck>,
#	python3-cryptography <!nocheck>,
#	python3-iso8601 <!nocheck>,
#	python3-pyasn1 <!nocheck>,
#	tdb-tools <!nocheck>,
Build-Conflicts-Arch:
 libtasn1-bin <!pkg.samba.dumpmscat>,
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/samba-team/samba
Vcs-Git: https://salsa.debian.org/samba-team/samba.git

Package: samba
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: passwd,
         samba-common,
         samba-common-bin (=${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: ctdb,
          ufw,
          winbind,
          python3-samba,
          samba-vfs-ceph, samba-vfs-glusterfs,
          attr,
# move libdfs-server-ad-samba4.so.0 samba-libs=>samba-vfs-modules in 4.19.0~rc1
# swallow samba-vfs-modules by samba in 4.20.2-dfsg-3
Replaces: samba-libs (<< 2:4.19.0~),
          samba-vfs-modules (<< 2:4.20.2+dfsg-3~),
Breaks:   samba-ad-provision (<< ${source:Upstream-Version}),
          samba-libs (<< 2:4.19.0~),
          samba-vfs-modules (<< 2:4.20.2+dfsg-3~),
          samba-ad-dc (<< 2:4.20.1+dfsg-2~),
Description: SMB/CIFS file, print, and login server for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.  Samba can also function
 as an Active Directory or NT4-style domain controller, and can integrate
 with Active Directory realms or NT4 domains as a member server.
 .
 This package provides the components necessary to use Samba as a stand-alone
 file and print server or as an NT4 domain controller.  For use in an NT4
 domain or Active Directory realm, you will also need the winbind package.
 To use samba as an Active Directory domain controller (AD DC), please install
 samba-ad-dc package.
 .
 This package is not required for connecting to existing SMB/CIFS servers
 (see smbclient) or for mounting remote filesystems (see cifs-utils).

Package: samba-libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Provides: libndr6 (= ${binary:Version}),
# libndr5=>6 dropped 3 long-unused KRB5_EDATA_NTSTATUS symbols
 libndr5 (= ${binary:Version}),
 libsmbldap2 (= ${binary:Version})
Depends: ${misc:Depends}, ${shlibs:Depends},
# since libldb ABI is incorrectly versioned resulting in breakage like #1021371,
# just require libldb version of the same build
# https://lists.samba.org/archive/samba-technical/2023-September/138422.html
 libldb2 (= ${ldb:Version}),
Breaks:
 sssd-ad (<< 2.9.4-1+b1),
 sssd-ad-common (<< 2.9.4-1+b1),
 sssd-ipa (<< 2.9.4-1+b1),
Description: Samba core libraries
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains the shared libraries.

Package: samba-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ucf, ${misc:Depends}
Recommends: samba-common-bin
Description: common files used by both the Samba server and client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains common files used by all parts of Samba.

Package: samba-common-bin
Architecture: any
Depends: samba-common,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-samba [!i386],
Suggests: heimdal-clients,
# moved libnet-keytab-samba4.so.0 & libRPC-WORKER-samba4.so.0 samba-libs=>samba-common-bin in 4.19.0~r1
# moved smbcontrol samba=>samba-common-bin in 4.20.0-2
# in kali linux, winexe initially has been in its own pkg (#1081269)
Replaces: samba (<< 2:4.20.1+dfsg-2~), samba-libs (<< 2:4.19.0~), winexe (<< 2:4.21.1+dfsg-3~)
Breaks:   samba (<< 2:4.20.1+dfsg-2~), samba-libs (<< 2:4.19.0~), winexe (<< 2:4.21.1+dfsg-3~)
Provides: winexe (= ${binary:Version})
Description: Samba common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the smbclient
 package).

Package: samba-ad-dc
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: samba (= ${binary:Version}),
	 python3-samba (= ${binary:Version}),
	 python3-dnspython,
	 samba-dsdb-modules (= ${binary:Version}),
	 winbind (= ${binary:Version}),
	 krb5-kdc (>= 1.21.0~) <pkg.samba.mitkrb5>,
	 ${python3:Depends},
	 ${shlibs:Depends},
	 ${misc:Depends}
Recommends: libnss-winbind, libpam-winbind,
# samba-ad-provision is needed for setup only
	samba-ad-provision,
# used in a few AD-related subcommands of samba-tool (see #876984)
        python3-gpg,
Suggests: bind9,
	  bind9utils,
	  ldb-tools,
# Besides wanting accurate time, samba DC can provide signed time source
# to the domain using special socket (see "ntp signd socket directory"
# in smb.conf(5)).  There was a (wrong) patch to ntp to work with samba,
# it has been dropped in ntpsec.
	  time-daemon | chrony | ntpsec,
Enhances: bind9, ntpsec
Breaks:   samba-ad-provision (<< ${source:Upstream-Version}),
# files moved from samba & samba-common-bin in 4.20.1-2:
	  samba-common-bin (<< 2:4.20.1+dfsg-2~),
Replaces: samba-common-bin (<< 2:4.20.1+dfsg-2~),
# Breaks+Replaces upgraded to Conflicts for DEP17 + /usr-move
Conflicts: samba (<< 2:4.20.1+dfsg-2~),
Description: Samba control files to run AD Domain Controller
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains control files to run an Active Directory Domain
 Controller (AD DC).  For now, this is just a metapackage pulling in
 all the required dependencies.

Package: samba-ad-provision
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 python3-markdown,
Description: Samba files needed for AD domain provision
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains files to setup an Active Directory Domain
 Controller (AD DC).

Package: smbclient
Architecture: any
Depends: samba-common,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: samba-client
Suggests: cifs-utils, heimdal-clients
Description: command-line SMB/CIFS clients for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains command-line utilities for accessing Microsoft
 Windows and Samba servers, including smbclient, smbtar, and smbspool.
 Utilities for mounting shares locally are found in the package
 cifs-utils.

Package: samba-testsuite
Architecture: any
Suggests: subunit
Depends: samba-common-bin,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
# move libshares-samba4.so.0 samba-libs=>samba-testsuite in 4.19.0~rc1
Replaces: samba-libs (<< 2:4.19.0~)
Breaks:   samba-libs (<< 2:4.19.0~)
Description: test suite from Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: samba-dev
Architecture: any
Multi-Arch: same
Depends: libc6-dev,
         libldb-dev,
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev,
         libtevent-dev,
         libwbclient-dev,
         samba-libs (= ${binary:Version}),
         ${misc:Depends}
Section: devel
Description: tools for extending Samba

## samba 4.23.6+dfsg

=== debian/changelog ===
samba (2:4.23.6+dfsg-1.0nosystemd1) nosystemd; urgency=medium

  * No systemd/elogind 

 -- anticapitalista <antix@operamail.com>  Sat, 28 Feb 2026 19:03:29 +0200

samba (2:4.23.6+dfsg-1) unstable; urgency=medium

  * new upstream stable/bugfix release.
  * d/clean: also remove python/samba/provision/kerberos_implementation.py
    (Closes: #1048754)
  * check-for-openat2.patch: detect openat2 in libc (Closes: #1128849)

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 27 Feb 2026 13:11:48 +0300

=== debian/rules ===
--- 
+++ 
@@ -141,13 +141,13 @@
 
 config-args += \
 	--with-quota \
-	--with-systemd \
+	\
 
 endif
 
 # Ubuntu i386 binary compatibility only effort: Disable some i386 packages and modules
 ifeq (${DEB_VENDOR}-${DEB_HOST_ARCH}, Ubuntu-i386)
-omit-pkgs += ctdb libpam-winbind samba samba-ad-dc samba-testsuite samba-vfs-modules samba-vfs-ceph samba-vfs-glusterfs python3-samba
+omit-pkgs += ctdb libpam-winbind samba samba-ad-dc samba-testsuite samba-vfs-modules samba-vfs-ceph samba-vfs-glusterfs
 endif
 
 # we had t64 transition (libsmbclient => libsmbclient0) for trixie

## samba 4.24.0~rc1%2Bdfsg

=== python/wscript ===
#!/usr/bin/env python

import os
from waflib import Options, Errors

# work out what python external libraries we need to be successful
selftest_pkgs = {
    'cryptography': 'python3-cryptography',
    'pyasn1': 'python3-pyasn1'
}

ad_dc_pkgs = {
    'markdown': 'python3-markdown',
    'dns': 'python3-dnspython (python3-dns on some systems)'
}


def find_third_party_module(conf, module, package, required=True):
    conf.COMPOUND_START("Checking for system installation of Python module %s" % module)
    try:
        __import__(module)
    except ImportError:
        conf.COMPOUND_END(False)
        if not required:
            return False
        raise Errors.WafError("""\
        Unable to find Python module '%s'. Please install the system package: %s'.
""" % (module, package))
    else:
        # Installed on the system
        conf.COMPOUND_END("system")

    return True


def configure(conf):
    if conf.env.disable_python:
        return

    kerberos_py = conf.srcnode.abspath() + "/python/samba/provision/kerberos_implementation.py"

    f = open(kerberos_py, 'w')
    try:
        header = """#
# Copyright (c) 2016      Andreas Schneider <asn@samba.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
"""
        f.write(header)

        data = """kdb_modules_dir = "{0}"
"""

        if conf.env.HEIMDAL_KRB5_CONFIG:
            f.write(data.format(""))
        else:
            modulesdir = "%s/krb5/plugins/kdb" % conf.env.LIBDIR

            f.write(data.format(modulesdir))
    finally:
        f.close()

    # In many places we fill in a uint32_t with an unsigned int, using
    # PyArg_ParseTuple("I"), which will overwrite memory if the size
    # of the int is not 4. There are no systems on which Samba will
    # compile where int is not 32 bit, but we are testing in case this
    # changes.
    if 'SIZEOF_INT' not in conf.env:
        conf.CHECK_SIZEOF('int uint32_t')
    sizeof_int = conf.env['SIZEOF_INT']
    sizeof_uint32 = conf.env['SIZEOF_UINT32_T']
    if sizeof_int != sizeof_uint32:
        conf.fatal("Samba python bindings won't work with int bigger than uint32_t "
                   f"(int: {sizeof_int}, uint32_t: {sizeof_uint32}).")

    if conf.CONFIG_GET('ENABLE_SELFTEST'):
        for module, package in selftest_pkgs.items():
            find_third_party_module(conf, module, package)

        # Prefer dateutil.parser which is much more widely used.
        if not find_third_party_module(conf,
                                       'dateutil.parser',
                                       'python3-dateutilis',
                                       required=False):
            if not find_third_party_module(conf,
                                           'iso8601',
                                           'python3-iso8601',
                                           required=False):
                raise Errors.WafError("Could not find Python package "
                                      "'python3-dateutils' nor "
                                      "'python3-iso8601'. Please install "
                                      "one of the packages.")

    if not Options.options.without_ad_dc:
        for module, package in ad_dc_pkgs.items():
            find_third_party_module(conf, module, package)


def build(bld):


    pytalloc_util = bld.pyembed_libname('pytalloc-util')
    pyparam_util = bld.pyembed_libname('pyparam_util')
    libpython = bld.pyembed_libname('LIBPYTHON')
    pyrpc_util = bld.pyembed_libname('pyrpc_util')
    samba_python = bld.pyembed_libname('samba_python')
    bld.SAMBA_LIBRARY(samba_python,
                      source=[],
                      deps='%s %s %s' % (libpython, pytalloc_util, pyrpc_util),
                      grouping_library=True,
                      private_library=True,
                      pyembed=True,
                      enabled=bld.PYTHON_BUILD_IS_ENABLED())
    bld.SAMBA_PYTHON('python_glue',
                     source='pyglue.c',
                     deps='''
                              %s
                              samba-util
                              netif
                              ndr
                              cmdline
                              gkdi
                              util_crypt
                              %s
                              ''' % (pyparam_util, pytalloc_util),
                     realname='samba/_glue.so')

    bld.SAMBA_SUBSYSTEM(libpython,
                        source='modules.c',
                        public_deps='',
                        init_function_sentinel='{NULL,NULL}',
                        deps='talloc',
                        pyext=True,
                        enabled=bld.PYTHON_BUILD_IS_ENABLED())

    if bld.PYTHON_BUILD_IS_ENABLED():
        # install out various python scripts for use by make test
        bld.SAMBA_SCRIPT('samba_python_files',
                         pattern='samba/**/*.py',
                         installdir='python')

        bld.INSTALL_WILDCARD('${PYTHONARCHDIR}', 'samba/**/*.py', flat=False)
